Index: palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3291)
+++ palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3289 2018-09-28 10:23:58Z suehring
 ! Introduce module parameter for number of inflow profiles
 ! 
@@ -77,5 +80,4 @@
 
     USE control_parameters
-     
 
     IMPLICIT NONE
@@ -99,10 +101,10 @@
 
 
-    PUBLIC rrd_global, rrd_read_parts_of_global, rrd_local,      & 
-           rrd_skip_global
+    PUBLIC rrd_global, rrd_read_parts_of_global, rrd_local, rrd_skip_global
 
 
  CONTAINS
 
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -115,5 +117,5 @@
        USE arrays_3d,                                                          &
            ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,        &
-                  q_init, ref_state, s_init, sa_init, u_init, ug, v_init, vg
+                  q_init, ref_state, sa_init, s_init, u_init, ug, v_init, vg
 
        USE bulk_cloud_model_mod,                                               &
@@ -140,4 +142,7 @@
        USE netcdf_interface,                                                   &
            ONLY:  netcdf_precision, output_for_t0
+
+       USE ocean_mod,                                                          &
+           ONLY:  ocean_rrd_global
 
        USE particle_attributes,                                                &
@@ -177,7 +182,6 @@
 
        CALL check_open( 13 )
-
-!
-!-- Make version number check first
+!
+!--    Make version number check first
        READ ( 13 )  length
        READ ( 13 )  restart_string(1:length)
@@ -196,6 +200,6 @@
 
 !
-!-- Read number of PEs and horizontal index bounds of all PEs used in previous
-!-- run
+!--    Read number of PEs and horizontal index bounds of all PEs used in the
+!--    previous run
        READ ( 13 )  length
        READ ( 13 )  restart_string(1:length)
@@ -223,7 +227,7 @@
 
 !
-!-- Read vertical number of gridpoints and number of different areas used
-!-- for computing statistics. Allocate arrays depending on these values,
-!-- which are needed for the following read instructions.
+!--    Read vertical number of gridpoints and number of different areas used
+!--    for computing statistics. Allocate arrays depending on these values,
+!--    which are needed for the following read instructions.
        READ ( 13 )  length
        READ ( 13 )  restart_string(1:length)
@@ -257,4 +261,5 @@
        ENDIF
        READ ( 13 )  statistic_regions
+
        IF ( .NOT. ALLOCATED( ug ) )  THEN
           ALLOCATE( ug(0:nz+1), u_init(0:nz+1), vg(0:nz+1),                    &
@@ -266,9 +271,9 @@
 
 !
-!-- Now read all control parameters:
-!-- Caution: When the following read instructions have been changed, the
-!-- -------  version number stored in the variable binary_version_global has to
-!--          be increased. The same changes must also be done in 
-!--          wrd_write_global.
+!--    Now read all control parameters:
+!--    Caution: When the following read instructions have been changed, the
+!--    -------  version number stored in the variable binary_version_global has
+!--             to be increased. The same changes must also be done in
+!--             wrd_write_global.
        READ ( 13 )  length
        READ ( 13 )  restart_string(1:length)
@@ -318,12 +323,8 @@
              CASE ( 'bc_s_t' )
                 READ ( 13 )  bc_s_t
-             CASE ( 'bc_sa_t' )
-                READ ( 13 )  bc_sa_t
              CASE ( 'bc_uv_b' )
                 READ ( 13 )  bc_uv_b
              CASE ( 'bc_uv_t' )
                 READ ( 13 )  bc_uv_t
-             CASE ( 'bottom_salinityflux' )
-                READ ( 13 )  bottom_salinityflux
              CASE ( 'building_height' )
                 READ ( 13 )  building_height
@@ -496,6 +497,6 @@
                 READ ( 13 )  ny
                 ny_on_file = ny
-             CASE ( 'ocean' )
-                READ ( 13 )  ocean
+             CASE ( 'ocean_mode' )
+                READ ( 13 )  ocean_mode
              CASE ( 'old_dt' )
                 READ ( 13 )  old_dt
@@ -580,12 +581,4 @@
              CASE ( 's_vertical_gradient_level_ind' )
                 READ ( 13 )  s_vertical_gradient_level_ind
-             CASE ( 'sa_init' )
-                READ ( 13 )  sa_init
-             CASE ( 'sa_surface' )
-                READ ( 13 )  sa_surface
-             CASE ( 'sa_vertical_gradient' )
-                READ ( 13 )  sa_vertical_gradient
-             CASE ( 'sa_vertical_gradient_level' )
-                READ ( 13 )  sa_vertical_gradient_level
              CASE ( 'scalar_advec' )
                 READ ( 13 )  scalar_advec
@@ -662,6 +655,4 @@
              CASE ( 'top_momentumflux_v' )
                 READ ( 13 )  top_momentumflux_v
-             CASE ( 'top_salinityflux' )
-                READ ( 13 )  top_salinityflux
              CASE ( 'top_scalarflux' )
                 READ ( 13 )  top_scalarflux
@@ -754,6 +745,4 @@
              CASE ( 'wall_humidityflux' )
                 READ ( 13 )  wall_humidityflux
-             CASE ( 'wall_salinityflux' )
-                READ ( 13 )  wall_salinityflux
              CASE ( 'wall_scalarflux' )
                 READ ( 13 )  wall_scalarflux
@@ -769,18 +758,16 @@
                 READ ( 13 )  z_i
 
-
              CASE DEFAULT
-
-                IF ( .NOT. found ) CALL bcm_rrd_global( found )
-
-                IF ( .NOT. found ) CALL wtm_rrd_global( found )
-
-                IF ( .NOT. found ) CALL flight_rrd_global( found )
-
-                IF ( .NOT. found ) CALL stg_rrd_global ( found )
-
-                IF ( .NOT. found ) CALL gust_rrd_global( found )
-
-                IF ( .NOT. found ) CALL user_rrd_global( found )
+!
+!--             Read global variables from of other modules
+                IF ( .NOT. found )  CALL bcm_rrd_global( found )
+                IF ( .NOT. found )  CALL flight_rrd_global( found )
+                IF ( .NOT. found )  CALL gust_rrd_global( found )
+                IF ( .NOT. found )  CALL ocean_rrd_global( found )
+                IF ( .NOT. found )  CALL stg_rrd_global ( found )
+                IF ( .NOT. found )  CALL wtm_rrd_global( found )
+!
+!--             Read user-defined global variables
+                IF ( .NOT. found )  CALL user_rrd_global( found )
 
                 IF ( .NOT. found )  THEN
@@ -1049,7 +1036,9 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  e, kh, km, p, pt, q, ql, &
-               s, sa, u, u_m_l, u_m_n, u_m_r, u_m_s, v, v_m_l, v_m_n,      &
-               v_m_r, v_m_s, vpt, w, w_m_l, w_m_n, w_m_r, w_m_s
+        ONLY:  e, kh, km, p, pt, q, ql, s, u, u_m_l, u_m_n, u_m_r, u_m_s,      &
+               v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, w, w_m_l, w_m_n, w_m_r, w_m_s
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY :  bcm_rrd_local
 
     USE averaging
@@ -1073,6 +1062,6 @@
         ONLY:  lsm_rrd_local
 
-    USE bulk_cloud_model_mod,                                                  &
-        ONLY :  bcm_rrd_local
+    USE ocean_mod,                                                             &
+        ONLY:  ocean_rrd_local
 
     USE particle_attributes,                                                   &
@@ -1599,12 +1588,4 @@
                    DEALLOCATE( tmp_2d_id_random, tmp_2d_seq_random )
 
-                CASE ( 'rho_ocean_av' )
-                   IF ( .NOT. ALLOCATED( rho_ocean_av ) )  THEN
-                      ALLOCATE( rho_ocean_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   rho_ocean_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =   &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-                           
                 CASE ( 's' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -1618,17 +1599,4 @@
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
                    s_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =           &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'sa' )
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   sa(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =             &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'sa_av' )
-                   IF ( .NOT. ALLOCATED( sa_av ) )  THEN
-                      ALLOCATE( sa_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   sa_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =          &
                       tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
@@ -1884,5 +1852,5 @@
 
 !
-!--                Read microphysics module restart data
+!--                Read restart data of other modules
                    IF ( .NOT. found ) CALL bcm_rrd_local( i, k, nxlf,          &
                                            nxlc, nxl_on_file, nxrf, nxrc,      &
@@ -1891,22 +1859,16 @@
                                            nys_on_file, tmp_2d, tmp_3d, found )
 
-!
-!--                Read surface related variables
-                   IF ( .NOT. found ) CALL surface_rrd_local( i, k, nxlf,      &
-                                           nxlc, nxl_on_file, nxrf, nxrc,      & 
+                   IF ( .NOT. found ) CALL chem_rrd_local( i, k, nxlf,         &
+                                           nxlc, nxl_on_file, nxrf, nxrc,      &
                                            nxr_on_file, nynf, nync,            & 
                                            nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, found )
-
-!
-!--                Read urban surface restart data
-                   IF ( .NOT. found ) CALL usm_rrd_local( i, k, nxlf,          & 
+                                           nys_on_file, tmp_3d, found )
+
+                   IF ( .NOT. found ) CALL gust_rrd_local( i, k, nxlf,         &
                                            nxlc, nxl_on_file, nxrf, nxrc,      &
                                            nxr_on_file, nynf, nync,            &
                                            nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, found )
-
-!
-!--                Read land surface restart data
+                                           nys_on_file, tmp_2d, tmp_3d, found )
+
                    IF ( .NOT. found ) CALL lsm_rrd_local( i, k, nxlf,          & 
                                            nxlc, nxl_on_file, nxrf, nxrc,      &
@@ -1915,6 +1877,10 @@
                                            nys_on_file, tmp_2d, found )
 
-!
-!--                Read radiation restart data
+                   IF ( .NOT. found ) CALL ocean_rrd_local( i, k, nxlf,        &
+                                           nxlc, nxl_on_file, nxrf, nxrc,      &
+                                           nxr_on_file, nynf, nync,            &
+                                           nyn_on_file, nysf, nysc,            &
+                                           nys_on_file, tmp_2d, tmp_3d, found )
+
                    IF ( .NOT. found ) CALL radiation_rrd_local( i, k, nxlf,    &
                                            nxlc, nxl_on_file, nxrf, nxrc,      &
@@ -1923,19 +1889,15 @@
                                            nys_on_file, tmp_2d, tmp_3d, found )
 
-!
-!--                Read chemistry restart data
-                   IF ( .NOT. found ) CALL chem_rrd_local( i, k, nxlf,         &
+                   IF ( .NOT. found ) CALL surface_rrd_local( i, k, nxlf,      &
                                            nxlc, nxl_on_file, nxrf, nxrc,      &
                                            nxr_on_file, nynf, nync,            & 
                                            nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, tmp_3d, found )
-
-!
-!--                Read gust module restart data
-                   IF ( .NOT. found ) CALL gust_rrd_local( i, k, nxlf,         &
+                                           nys_on_file, found )
+
+                   IF ( .NOT. found ) CALL usm_rrd_local( i, k, nxlf,          &
                                            nxlc, nxl_on_file, nxrf, nxrc,      &
                                            nxr_on_file, nynf, nync,            &
                                            nyn_on_file, nysf, nysc,            &
-                                           nys_on_file, tmp_2d, tmp_3d, found )
+                                           nys_on_file, found )
 
 !
Index: palm/trunk/SOURCE/subsidence_mod.f90
===================================================================
--- palm/trunk/SOURCE/subsidence_mod.f90	(revision 3291)
+++ palm/trunk/SOURCE/subsidence_mod.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! ocean renamed ocean_mode
+! 
+! 3045 2018-05-28 07:55:41Z Giersch
 ! Error message revised
 ! 
@@ -126,5 +129,5 @@
 
        USE control_parameters,                                                 &
-           ONLY:  message_string, ocean, subs_vertical_gradient,               &
+           ONLY:  message_string, ocean_mode, subs_vertical_gradient,          &
                   subs_vertical_gradient_level, subs_vertical_gradient_level_i
 
@@ -147,7 +150,7 @@
        ENDIF 
 
-       IF ( ocean )  THEN
+       IF ( ocean_mode )  THEN
           message_string = 'Applying large scale vertical motion is not ' //   &
-                           'allowed for ocean runs'
+                           'allowed for ocean mode'
           CALL message( 'init_w_subsidence', 'PA0324', 2, 2, 0, 6, 0 )
        ENDIF
Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3291)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3291 2018-09-28 11:33:03Z scharf
 ! corrected previous commit for 3D topography
 ! 
@@ -211,14 +214,13 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  dzw, e, heatflux_output_conversion, nc, nr, p, prr, pt,         &
-               q, qc, ql, ql_c, ql_v, qr, rho_ocean, s, sa, u, v, vpt, w,      &
-               waterflux_output_conversion, d_exner
+        ONLY:  dzw, d_exner, e, heatflux_output_conversion, nc, nr, p, prr,    &
+               pt, q, qc, ql, ql_c, ql_v, qr, s, u, v, vpt, w,                 &
+               waterflux_output_conversion
 
     USE averaging,                                                             &
-        ONLY:  e_av, ghf_av, lpt_av, lwp_av,                                   &
-               ol_av, p_av, pc_av, pr_av, pt_av, q_av, ql_av,                  &
-               ql_c_av, ql_v_av, ql_vp_av, qsws_av, qv_av, r_a_av,             &
-               rho_ocean_av, s_av, sa_av, shf_av, ssws_av, ts_av, tsurf_av,    &
-               u_av, us_av, v_av, vpt_av, w_av, z0_av, z0h_av, z0q_av
+        ONLY:  e_av, ghf_av, lpt_av, lwp_av, ol_av, p_av, pc_av, pr_av, pt_av, &
+               q_av, ql_av, ql_c_av, ql_v_av, ql_vp_av, qsws_av, qv_av,        &
+               r_a_av, s_av, shf_av, ssws_av, ts_av, tsurf_av, u_av, us_av,    &
+               v_av, vpt_av, w_av, z0_av, z0h_av, z0q_av
 
     USE basic_constants_and_equations_mod,                                     &
@@ -232,6 +234,6 @@
 
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, average_count_3d, doav, doav_n,                  &
-               land_surface, rho_surface, urban_surface, uv_exposure,          &
+        ONLY:  air_chemistry, average_count_3d, doav, doav_n, land_surface,    &
+               ocean_mode, rho_surface, urban_surface, uv_exposure,            &
                varnamelength
 
@@ -249,4 +251,7 @@
     USE land_surface_model_mod,                                                &
         ONLY:  lsm_3d_data_averaging
+
+    USE ocean_mod,                                                             &
+        ONLY:  ocean_3d_data_averaging
 
     USE particle_attributes,                                                   &
@@ -412,10 +417,4 @@
                 r_a_av = 0.0_wp
 
-             CASE ( 'rho_ocean' )
-                IF ( .NOT. ALLOCATED( rho_ocean_av ) )  THEN
-                   ALLOCATE( rho_ocean_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                ENDIF
-                rho_ocean_av = 0.0_wp
-
              CASE ( 's' )
                 IF ( .NOT. ALLOCATED( s_av ) )  THEN
@@ -423,10 +422,4 @@
                 ENDIF
                 s_av = 0.0_wp
-
-             CASE ( 'sa' )
-                IF ( .NOT. ALLOCATED( sa_av ) )  THEN
-                   ALLOCATE( sa_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                ENDIF
-                sa_av = 0.0_wp
 
              CASE ( 'shf*' )
@@ -501,8 +494,8 @@
                 ENDIF
                 z0q_av = 0.0_wp
+
+             CASE ( 'usm_output' )
 !             
-!--          Block of urban surface model outputs 
-             CASE ( 'usm_output' )
-
+!--             Block of urban surface model outputs
                 CALL usm_average_3d_data( 'allocate', doav(ii) )
               
@@ -511,45 +504,37 @@
 
 !
-!--             Turbulence closure module
-                CALL tcm_3d_data_averaging( 'allocate', doav(ii) )
-
-!
-!--             Microphysics module quantities
+!--             Allocating and initializing data arrays for other modules
                 IF ( bulk_cloud_model )  THEN
                    CALL bcm_3d_data_averaging( 'allocate', doav(ii) )
                 ENDIF
 
-!
-!--             Land surface quantity
+                IF ( air_chemistry  .AND.  trimvar(1:3) == 'kc_')  THEN
+                   CALL chem_3d_data_averaging( 'allocate', doav(ii) )
+                ENDIF
+
+                IF ( gust_module_enabled )  THEN
+                   CALL gust_3d_data_averaging( 'allocate', doav(ii) )
+                ENDIF
+
                 IF ( land_surface )  THEN
                    CALL lsm_3d_data_averaging( 'allocate', doav(ii) )
                 ENDIF
 
-!
-!--             Radiation quantity
+                IF ( ocean_mode )  THEN
+                   CALL ocean_3d_data_averaging( 'allocate', doav(ii) )
+                ENDIF
+
                 IF ( radiation )  THEN
                    CALL radiation_3d_data_averaging( 'allocate', doav(ii) )
                 ENDIF
 
-!
-!--             Gust module quantities
-                IF ( gust_module_enabled )  THEN
-                   CALL gust_3d_data_averaging( 'allocate', doav(ii) )
-                ENDIF
-
-!
-!--             Chemical quantity                                           
-                IF ( air_chemistry  .AND.  trimvar(1:3) == 'kc_')  THEN
-                   CALL chem_3d_data_averaging( 'allocate', doav(ii) )
-                ENDIF
-
-!
-!--             UV exposure quantity
                 IF ( uv_exposure  .AND.  trimvar(1:5) == 'uvem_')  THEN
                    CALL uvem_3d_data_averaging( 'allocate', doav(ii) )
                 ENDIF
 
-!
-!--             User-defined quantity
+                CALL tcm_3d_data_averaging( 'allocate', doav(ii) )
+
+!
+!--             User-defined quantities
                 CALL user_3d_data_averaging( 'allocate', doav(ii) )
 
@@ -877,15 +862,4 @@
              ENDIF
 
-          CASE ( 'rho_ocean' )
-             IF ( ALLOCATED( rho_ocean_av ) ) THEN 
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         rho_ocean_av(k,j,i) = rho_ocean_av(k,j,i) + rho_ocean(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF  
-
           CASE ( 's' )
              IF ( ALLOCATED( s_av ) ) THEN 
@@ -894,15 +868,4 @@
                       DO  k = nzb, nzt+1
                          s_av(k,j,i) = s_av(k,j,i) + s(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-
-          CASE ( 'sa' )
-             IF ( ALLOCATED( sa_av ) ) THEN 
-                DO  i = nxlg, nxrg
-                   DO  j = nysg, nyng
-                      DO  k = nzb, nzt+1
-                         sa_av(k,j,i) = sa_av(k,j,i) + sa(k,j,i)
                       ENDDO
                    ENDDO
@@ -1182,10 +1145,11 @@
                 ENDDO
              ENDIF
+
+          CASE ( 'usm_output' )
 !             
-!--       Block of urban surface model outputs. 
-!--       In case of urban surface variables it should be always checked
-!--       if respective arrays are allocated, at least in case of a restart 
-!--       run, as averaged usm arrays are not read from file at the moment. 
-          CASE ( 'usm_output' )
+!--          Block of urban surface model outputs.
+!--          In case of urban surface variables it should be always checked
+!--          if respective arrays are allocated, at least in case of a restart
+!--          run, as averaged usm arrays are not read from file at the moment.
              CALL usm_average_3d_data( 'allocate', doav(ii) )
              CALL usm_average_3d_data( 'sum', doav(ii) )
@@ -1193,39 +1157,31 @@
           CASE DEFAULT
 !
-!--          Turbulence closure module
-             CALL tcm_3d_data_averaging( 'sum', doav(ii) )
-
-!
-!--          Microphysics module quantities
+!--          Summing up data from other modules
              IF ( bulk_cloud_model )  THEN
                 CALL bcm_3d_data_averaging( 'sum', doav(ii) )
              ENDIF
 
-!
-!--          Land surface quantity
+             IF ( air_chemistry  .AND.  trimvar(1:3) == 'kc_')  THEN
+                CALL chem_3d_data_averaging( 'sum',doav(ii) )
+             ENDIF
+
+             IF ( gust_module_enabled )  THEN
+                CALL gust_3d_data_averaging( 'sum', doav(ii) )
+             ENDIF
+
              IF ( land_surface )  THEN
                 CALL lsm_3d_data_averaging( 'sum', doav(ii) )
              ENDIF
 
-!
-!--          Radiation quantity
+             IF ( ocean_mode )  THEN
+                CALL ocean_3d_data_averaging( 'sum', doav(ii) )
+             ENDIF
+
              IF ( radiation )  THEN
                 CALL radiation_3d_data_averaging( 'sum', doav(ii) )
              ENDIF
 
-!
-!--          Gust module quantities
-             IF ( gust_module_enabled )  THEN
-                CALL gust_3d_data_averaging( 'sum', doav(ii) )
-             ENDIF
-
-!
-!--          Chemical quantity
-             IF ( air_chemistry  .AND.  trimvar(1:3) == 'kc_')  THEN
-                CALL chem_3d_data_averaging( 'sum',doav(ii) )
-             ENDIF
-
-!
-!--          UV exposure quantity
+             CALL tcm_3d_data_averaging( 'sum', doav(ii) )
+
              IF ( uv_exposure )  THEN
                 CALL uvem_3d_data_averaging( 'sum', doav(ii) )
@@ -1233,5 +1189,5 @@
 
 !
-!--          User-defined quantity
+!--          User-defined quantities
              CALL user_3d_data_averaging( 'sum', doav(ii) )
 
Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 3291)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 3294)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -1114,5 +1117,5 @@
 !
 !--    Salinity surface flux
-       IF ( ocean )  DEALLOCATE ( surfaces%sasws )
+       IF ( ocean_mode )  DEALLOCATE ( surfaces%sasws )
 
     END SUBROUTINE deallocate_surface_attributes_h
@@ -1241,5 +1244,5 @@
 !
 !--    Salinity surface flux
-       IF ( ocean )  ALLOCATE ( surfaces%sasws(1:surfaces%ns) )
+       IF ( ocean_mode )  ALLOCATE ( surfaces%sasws(1:surfaces%ns) )
 
     END SUBROUTINE allocate_surface_attributes_h
@@ -1306,5 +1309,5 @@
 !
 !--    Salinity flux
-       IF ( ocean )  DEALLOCATE ( surfaces%sasws )
+       IF ( ocean_mode )  DEALLOCATE ( surfaces%sasws )
 
     END SUBROUTINE deallocate_surface_attributes_h_top
@@ -1378,5 +1381,5 @@
 !
 !--    Salinity flux
-       IF ( ocean )  ALLOCATE ( surfaces%sasws(1:surfaces%ns) )
+       IF ( ocean_mode )  ALLOCATE ( surfaces%sasws(1:surfaces%ns) )
 
     END SUBROUTINE allocate_surface_attributes_h_top
@@ -1496,5 +1499,5 @@
 !
 !--    Salinity surface flux
-       IF ( ocean )  DEALLOCATE ( surfaces%sasws )
+       IF ( ocean_mode )  DEALLOCATE ( surfaces%sasws )
 
     END SUBROUTINE deallocate_surface_attributes_v
@@ -1621,5 +1624,5 @@
 !
 !--    Salinity surface flux
-       IF ( ocean )  ALLOCATE ( surfaces%sasws(1:surfaces%ns) )
+       IF ( ocean_mode )  ALLOCATE ( surfaces%sasws(1:surfaces%ns) )
 
     END SUBROUTINE allocate_surface_attributes_v
@@ -2268,5 +2271,5 @@
                 ENDIF
 
-                IF ( ocean )  THEN
+                IF ( ocean_mode )  THEN
                    IF ( upward_facing )  THEN 
                       surf%sasws(num_h) = bottom_salinityflux * rho_air_zw(k-1)
@@ -2344,5 +2347,5 @@
 !
 !--          Prescribe top salinity flux
-             IF ( ocean .AND. constant_top_salinityflux)                       &
+             IF ( ocean_mode .AND. constant_top_salinityflux)                  &
                 surf%sasws(num_h) = top_salinityflux * rho_air_zw(nzt+1)
 !
@@ -2488,5 +2491,5 @@
 !--          So far, salinityflux at vertical surfaces is simply zero 
 !--          at the moment  
-             IF ( ocean )  surf%sasws(num_v) = wall_salinityflux(component)
+             IF ( ocean_mode )  surf%sasws(num_v) = wall_salinityflux(component)
 !
 !--          Increment wall indices
Index: palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- palm/trunk/SOURCE/swap_timelevel.f90	(revision 3291)
+++ palm/trunk/SOURCE/swap_timelevel.f90	(revision 3294)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! changes concerning modularization of ocean option
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -147,13 +150,10 @@
         ONLY:  chem_swap_timelevel 
 
-    USE land_surface_model_mod,                                                &
-        ONLY: lsm_swap_timelevel
-
     USE cpulog,                                                                &
         ONLY: cpu_log, log_point
 
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, humidity, land_surface,                          &
-               neutral, ocean, passive_scalar, timestep_count, urban_surface
+        ONLY:  air_chemistry, humidity, land_surface, neutral, ocean_mode,     &
+               passive_scalar, timestep_count, urban_surface
 
     USE gust_mod,                                                              &
@@ -164,4 +164,10 @@
         ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt
 #endif
+
+    USE land_surface_model_mod,                                                &
+        ONLY: lsm_swap_timelevel
+
+    USE ocean_mod,                                                             &
+        ONLY:  ocean_swap_timelevel
 
     USE pmc_interface,                                                         &
@@ -202,10 +208,4 @@
     ENDDO
 
-    CALL tcm_swap_timelevel ( 0 )
-
-    IF ( ocean )  THEN
-       sa = sa_p
-    ENDIF
-
     IF ( humidity )  THEN
        q = q_p
@@ -214,20 +214,12 @@
     IF ( passive_scalar )  s = s_p             
 
-    IF ( humidity  .AND.  bulk_cloud_model )  THEN
-       CALL bcm_swap_timelevel ( 0 )
-    ENDIF
-
-    IF ( land_surface )  THEN
-       CALL lsm_swap_timelevel ( 0 )
-    ENDIF
-
-    IF ( urban_surface )  THEN
-       CALL usm_swap_timelevel ( 0 )
-    ENDIF
-
-    IF ( gust_module_enabled )  THEN
-       CALL gust_swap_timelevel ( 0 )
-    ENDIF
-
+!
+!-- Swapping the timelevel of other modules
+    IF ( humidity  .AND.  bulk_cloud_model )  CALL bcm_swap_timelevel( 0 )
+    IF ( gust_module_enabled )                CALL gust_swap_timelevel( 0 )
+    IF ( land_surface )                       CALL lsm_swap_timelevel( 0 )
+    IF ( ocean_mode )                         CALL ocean_swap_timelevl( 0 )
+    CALL tcm_swap_timelevel( 0 )
+    IF ( urban_surface )                      CALL usm_swap_timelevel( 0 )
 
     CALL cpu_log( log_point(28), 'swap_timelevel (nop)', 'stop' )
@@ -245,5 +237,5 @@
              pt => pt_1;  pt_p => pt_2
           ENDIF
-          IF ( ocean )  THEN
+          IF ( ocean_mode )  THEN
              sa => sa_1;  sa_p => sa_2
           ENDIF
@@ -254,6 +246,4 @@
              s => s_1;    s_p => s_2
           ENDIF
-
-          IF ( air_chemistry )  CALL chem_swap_timelevel(0)
 
           swap_level = 1
@@ -267,5 +257,5 @@
              pt => pt_2;  pt_p => pt_1
           ENDIF
-          IF ( ocean )  THEN
+          IF ( ocean_mode )  THEN
              sa => sa_2;  sa_p => sa_1
           ENDIF
@@ -277,9 +267,9 @@
           ENDIF
 
-          IF ( air_chemistry )  CALL chem_swap_timelevel(1)
-
           swap_level = 2
 
     END SELECT
+
+    IF ( air_chemistry )  CALL chem_swap_timelevel( MOD( timestep_count, 2) )
 
     CALL tcm_swap_timelevel ( MOD( timestep_count, 2) )
